/* $Cambridge: hermes/src/prayer/prayer/cmd_abook_lookup.c,v 1.38 2005/10/05 10:56:42 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"


static void
html_button_single_table(struct session *s,
                         struct buffer *b,
                         char *cmd,
                         unsigned long offset, char *img, char *alt)
{
    bputs(b, "<td>");
    html_session_bprintf(s, b, "<a href=\"", "\">", "%s/%lu", cmd, offset);
    html_icon(s, b, img, alt);
    bputs(b, "</a></td>" CRLF);
}

static void
cmd_abook_lookup_hdr(struct session *session, struct buffer *b,
                     unsigned long offset, unsigned long count,
                     unsigned long per_page)
{
    struct config_theme *theme = session->theme_main;
    BOOL use_icons = session->user_agent->use_icons;
    unsigned long page;
    unsigned long pages;

    if (count > 0) {
        page = (offset / per_page) + 1;
        pages = ((count - 1) / per_page) + 1;
    } else {
        page = 0;
        pages = 0;
    }

    bputs(b, "<table width=\"100%\" cellspacing=0 cellpadding=0>" CRLF);
    if (config_theme_check_bgcolor(theme, theme->bgcolor_banner))
        bprintf(b, "<tr bgcolor=\"%s\">", theme->bgcolor_banner);
    else
        bputs(b, "<tr>");
    bputs(b, "<td width=\"33%\">" CRLF);
    bputs(b, "<table><tr>" CRLF);

    if (page > 1) {
        html_button_single_table(session, b, "abook_lookup", 1,
                                 "leftleft.gif", "First");
        if (!use_icons)
            bputs(b, "<td>|</td>");

        html_button_single_table(session, b, "abook_lookup",
                                 (offset - per_page), "left.gif",
                                 "Previous");
    } else {
        html_button_inactive_table(session, b, "leftleft-inactive.gif",
                                   "First");
        if (!use_icons)
            bputs(b, "<td>|</td>");
        html_button_inactive_table(session, b, "left-inactive.gif",
                                   "Previous");
    }

    if (!use_icons)
        bputs(b, "<td>|</td>");

    if (page < pages) {
        html_button_single_table(session, b, "abook_lookup",
                                 (offset + per_page), "right.gif", "Next");
        if (!use_icons)
            bputs(b, "<td>|</td>");
        html_button_single_table(session, b, "abook_lookup", count,
                                 "rightright.gif", "Last");
    } else {
        html_button_inactive_table(session, b, "right-inactive.gif",
                                   "Next");
        if (!use_icons)
            bputs(b, "<td>|</td>");
        html_button_inactive_table(session, b, "rightright-inactive.gif",
                                   "Last");
    }
    bputs(b, "</tr></table></td>" CRLF);

    bputs(b, "<td width =\"33%\" align=\"center\">");
    if (count != 1)
        bprintf(b, "<strong>Search Results (%lu entries)</strong>",
                count);
    else
        bprintf(b, "<strong>Search Results (1 entry)</strong>");

    bputs(b, "</td>" CRLF);

    bputs(b, "<td width=\"34%\" align=\"right\"><table><tr>" CRLF);
    bputs(b, "<td>&nbsp;</td>");
    bputs(b, "</tr></table></tr></table>" CRLF);
}

static void
cmd_abook_lookup_footer(struct session *session, struct buffer *b,
                        unsigned long offset, unsigned long count,
                        unsigned long per_page)
{
    struct config_theme *theme = session->theme_main;
    BOOL use_icons = session->user_agent->use_icons;
    unsigned long page;
    unsigned long pages;

    if (count > 0) {
        page = (offset / per_page) + 1;
        pages = ((count - 1) / per_page) + 1;
    } else {
        page = 0;
        pages = 0;
    }

    bputs(b, "<table width=\"100%\" cellspacing=0 cellpadding=0>" CRLF);
    if (config_theme_check_bgcolor(theme, theme->bgcolor_banner))
        bprintf(b, "<tr bgcolor=\"%s\">", theme->bgcolor_banner);
    else
        bputs(b, "<tr>");
    bputs(b, "<td width=\"33%\">" CRLF);
    bputs(b, "<table><tr>" CRLF);

    if (page > 1) {
        html_button_single_table(session, b, "abook_lookup", 1,
                                 "leftleft.gif", "First");
        if (!use_icons)
            bputs(b, "<td>|</td>");

        html_button_single_table(session, b, "abook_lookup",
                                 (offset - per_page), "left.gif",
                                 "Previous");
    } else {
        html_button_inactive_table(session, b, "leftleft-inactive.gif",
                                   "First");
        if (!use_icons)
            bputs(b, "<td>|</td>");
        html_button_inactive_table(session, b, "left-inactive.gif",
                                   "Previous");
    }

    if (!use_icons)
        bputs(b, "<td>|</td>");

    if (page < pages) {
        html_button_single_table(session, b, "abook_lookup",
                                 (offset + per_page), "right.gif", "Next");
        if (!use_icons)
            bputs(b, "<td>|</td>");
        html_button_single_table(session, b, "abook_lookup", count,
                                 "rightright.gif", "Last");
    } else {
        html_button_inactive_table(session, b, "right-inactive.gif",
                                   "Next");
        if (!use_icons)
            bputs(b, "<td>|</td>");
        html_button_inactive_table(session, b, "rightright-inactive.gif",
                                   "Last");
    }

    bputs(b, "</tr></table></td>" CRLF);

    bputs(b, "<td width=\"33%\" align=\"center\">");
    bputs(b, "<table><tr>");
    bputs(b, "<td>Page:</td>");
    bprintf(b, "<td><input name=\"page\" size=4 value=\"%lu\"></td>",
            page);
    bprintf(b, "<td>/%lu</td>", pages);
    bputs(b,
          "<td><input type=\"submit\" name=\"sub_page\" value=\"Go\"></td>");
    bputs(b, "</tr></table>");
    bputs(b, "</td>" CRLF);

    bputs(b, "<td width=\"34%\" align=\"right\"><table><tr>" CRLF);
    bputs(b, "<td>&nbsp;</td>");
    bputs(b, "</tr></table></tr></table>" CRLF);
}

/* Is display_name sufficiently different from registered_name to
   warant showing both? Ignore case, spaces and punctuation */

static BOOL
compare_display_ignore_char(char c)
{
    return ((c == ' ') || (c == '\t') || (c == ',') || (c == '.'));
}

static BOOL
compare_display_name(char *display, char *registered)
{
    while (1) {
        while (*display && compare_display_ignore_char(*display))
            display++;

        while (*registered && compare_display_ignore_char(*registered))
            registered++;

        if ((*display == '\0') || (*registered == '\0'))
            break;

        if (Utolower(*display) != Utolower(*registered))
            break;

        display++;
        registered++;
    }

    return (((*display == '\0') && (*registered == '\0')) ? T : NIL);
}

static void
cmd_abook_lookup_single(struct session *session, struct buffer *b,
                        struct lookup_item *entry, unsigned long offset,
                        BOOL have_draft, BOOL have_cancelled)
{
    struct pool *pool = b->pool;

    bprintf(b, "<td valign=\"top\"><strong>%lu.</strong></td>", offset);

    bputs(b, "<td valign=\"top\">");
    html_quote_string(b, entry->userid);
    bputs(b, "</td>"CRLF);

    if (!compare_display_name(entry->display_name, entry->registered_name)) {
        bputs(b, "<td valign=\"top\">");
        html_quote_string(b, entry->display_name);
        bputs(b, "<br>(");
        html_quote_string(b, entry->registered_name);
        bputs(b, ")</td>"CRLF);
    } else {
        bputs(b, "<td valign=\"top\">");
        html_quote_string(b, entry->display_name);
        bputs(b, "</td>"CRLF);
    }

    bputs(b, "<td valign=\"top\">");
    html_quote_string(b, entry->affiliation);
    bputs(b, "</td>"CRLF);

    if (have_cancelled) {
        if (entry->cancelled) {
            bputs(b,
                  "<td>CANCELLED</td><td>&nbsp;</td><td>&nbsp;</td></tr>"CRLF);
            return;
        }
        bputs(b, "<td>&nbsp;</td>");
    } else {
        bputs(b, "<td valign=\"top\">");
        html_quote_string(b, entry->phone);
        bputs(b, "</td>");
    }
        

    /* Some people have no email address listed */
    if (!(entry->email && entry->email[0])) {
        bputs(b, "<td>&nbsp;</td>");
        bputs(b, "<td>&nbsp;</td>"CRLF);
        return;
    }

    html_session_bprintf(session, b, "<td valign=\"top\"><a href=\"", "\">",
                         ("abook_take?alias=%s&amp;name=%s&amp;"
                          "comment=%s&amp;email=%s"),
                         string_url_encode(pool, entry->userid),
                         string_url_encode(pool, entry->display_name),
                         string_url_encode(pool, entry->affiliation),
                         string_url_encode(pool, entry->email));

    bputs(b, "Add</a></td>");

    if (have_draft) {
        bputs(b, "<td valign=\"top\">");
        bprintf(b, "<input type=\"checkbox\" name=\"to_%lu\">To" CRLF,
                offset);
        bprintf(b, "<input type=\"checkbox\" name=\"cc_%lu\">Cc" CRLF,
                offset);
        bprintf(b, "<input type=\"checkbox\" name=\"bcc_%lu\">Bcc" CRLF,
                offset);
        bputs(b, "</td>"CRLF);
    } else {
        /* Separate as may need to select role */
        html_session_bprintf(session, b, "<td valign=\"top\"><a href=\"",
                             "\">Compose</a></td>" CRLF,
                             "abook_compose/%s/%s",
                             string_canon_encode(pool, entry->display_name),
                             string_canon_encode(pool, entry->email));
    }
}

void
my_generate_page(struct session *session)
{
    struct prefs *prefs = session->options->prefs;
    struct config  *config = session->config;
    struct lookup  *lookup = session->lookup;
    struct request *request = session->request;
    struct buffer  *b = request->write_buffer;
    struct config_theme *theme = session->theme_main;
    BOOL have_draft = session->draft->have_draft;
    char *color;
    BOOL shaded = NIL;
    unsigned long i, offset, first, last;

    html_start(session, b, "Directory Lookup");
    html_banner_toolbar(session, b, "abook_lookup", 0);

    /* Link into directory */
    bputs(b, "<table width=\"100%\"><tr><td align=\"left\">");
    html_form_start(session, b, "POST", "abook_lookup");
    html_form_submit(b, "sub_cancel",  "Cancel Search");
    html_form_end(b);
    bputs(b, "</td>"CRLF);

    bputs(b, "<td align=\"right\">");
    html_form_start(session, b, "POST", "abook_lookup");
    bputs(b, "<table><tr>"CRLF);
    bputs(b, "<td>Surname:</td>");
    html_form_table_field(b, "", "query",
                          (lookup->query) ? lookup->query : "", 20);

    if (lookup_local_available(lookup)) {
        char *s;

        if (config->login_service_name)
            s = pool_printf(request->pool, "Search %s Users",
                            config->login_service_name);
        else
            s = "Search Local Users";

        html_form_table_submit(b, "sub_local", s);
    }
    if (lookup_ldap_available(lookup))
        html_form_table_submit(b, "sub_ldap",  "Search Directory");
    bputs(b, "</tr></table>"CRLF);
    html_form_end(b);
    bputs(b, "</td></tr></table>"CRLF);

    html_form_start(session, b, "POST", "abook_lookup");

    cmd_abook_lookup_hdr(session, b, lookup->current, lookup->count,
                         prefs->abook_per_page);

    bputs(b, "<table width=\"100%\">" CRLF);
    if (config_theme_check_bgcolor(theme, theme->bgcolor_banner))
        bprintf(b, "<tr bgcolor=\"%s\">", theme->bgcolor_banner);
    else
        bputs(b, "<tr>");

    bputs(b, "<td width=\"3%\">#</td>" CRLF);
    bputs(b, "<td width=\"5%\">Userid</td>" CRLF);
    bputs(b, "<td width=\"20%\">Name (Registered Name)</td>" CRLF);
    bputs(b, "<td width=\"42%\">Primary Affiliation</td>" CRLF);

    if (lookup->have_cancelled)
        bputs(b, "<td width=\"10%\">Cancelled?</td>" CRLF);
    else
        bputs(b, "<td width=\"10%\">Phone</td>" CRLF);

    bputs(b, "<td width=\"10%\">Addressbook</td>" CRLF);

    if (have_draft) {
        bputs(b, "<td width=\"10%\" align=\"center\">" CRLF);
        html_form_submit(b, "sub_add_address", "Add marked to draft");
        bputs(b, "</td>" CRLF);
    } else
        bputs(b, "<td width=\"10%\">&nbsp;</td>" CRLF);

    /* Calculate first and last entry on page. */
    offset = lookup->current;

    if (offset >= prefs->abook_per_page)
        first = (offset - ((offset - 1) % prefs->abook_per_page));
    else
        first = 1;

    last = (((first + (prefs->abook_per_page - 1)) <= lookup->count)
            ? (first + (prefs->abook_per_page - 1)) : lookup->count);

    for (i = first ; i <= last ; i++) {
        color = (shaded) ? theme->bgcolor_row1 : theme->bgcolor_row2;
        if (config_theme_check_bgcolor(theme, color))
            bprintf(b, "<tr bgcolor=\"%s\">", color);
        else
            bputs(b, "<tr>");

        cmd_abook_lookup_single(session, b, lookup->entries[i-1], i,
                                have_draft, lookup->have_cancelled);

        bputs(b, "</tr>"CRLF);
        shaded = (shaded) ? NIL : T;
    }
    bputs(b, "</table>");

    html_form_end(b);

    if (lookup->count > 0) {
        html_form_start(session, b, "POST", "abook_lookup");
        cmd_abook_lookup_footer(session, b, lookup->current, lookup->count,
                                prefs->abook_per_page);
        html_form_end(b);
    }

    html_end(b);
    response_html(request, 200);
}

static void
my_add_addresses(struct session *session)
{
    struct request *request = session->request;
    struct pool *pool = request->pool;
    struct draft *draft = session->draft;
    unsigned long offset;
    unsigned long count;
    struct lookup *lookup = session->lookup;
    struct lookup_item **entries = lookup->entries, *entry;
    unsigned long max = lookup->count;
    void (*fn)(struct draft *draft, char *text) = NIL; 
    char *key, *name;

    if (!entries)
        return;

    assoc_scan_reset(request->form);

    count = 0;
    while (assoc_scan_next(request->form, &key, NIL)) {
        if (!strncmp(key, "to_", strlen("to_"))) {
            key += strlen("to_");
            fn = draft_add_to;
        } else if (!strncmp(key, "cc_", strlen("cc_"))) {
            key += strlen("cc_");
            fn = draft_add_cc;
        } else if (!strncmp(key, "bcc_", strlen("bcc_"))) {
            key += strlen("bcc_");
            fn = draft_add_bcc;
        } else
            continue;

        if ((offset = atoi(key)) >= max)
            continue;

        entry = entries[offset-1];
        if (!(entry->email && entry->email[0]))
            continue;

        if (entry->display_name && entry->display_name[0])
            name = entry->display_name;
        else if (entry->registered_name && entry->registered_name[0])
            name = entry->registered_name;
        else
            name = "";

        (*fn)(draft, abook_text_to_string(pool, name, entry->email));
        count++;
    }

    if (count != 1)
        session_message(session, "Added %lu addresses to draft", count);
    else
        session_message(session, "Added 1 address to draft");
}

void cmd_abook_lookup(struct session *session)
{
    struct lookup  *lookup = session->lookup;
    struct prefs   *prefs = session->options->prefs;
    struct request *request = session->request;
    struct assoc   *h = NIL;
    char *query;
    BOOL do_ldap = NIL;

    if (request->method != POST) {
        if (request->argc == 2)
            lookup->current = atoi(request->argv[1]);  /* Move to page */

        my_generate_page(session);
        return;
    }

    request_decode_post(request);
    h = request->form;

    if (assoc_lookup(h, "sub_cancel")) {
        lookup_clear(lookup);
        session_redirect(session, request, "abook_list");
        return;
    }

    /* Record last command for addressbook take */
    session->take_parent_cmd = "abook_lookup";

    /* Record last command for compose/cancel and friends */
    if (!session->draft->have_draft)
        session->compose_parent_cmd = "abook_lookup";

    if (assoc_lookup(h, "sub_page")) {
        char *pstr = assoc_lookup(request->form, "page");
        unsigned long page = pstr ? atoi(pstr) : 0;
        unsigned long pages = (lookup->count / prefs->abook_per_page) + 1;

        if ((page > 0) && (page <= pages))
            lookup->current = (page - 1) * prefs->abook_per_page + 1;

        if (lookup->current > lookup->count)
            lookup->current = lookup->count;
        
        my_generate_page(session);
        return;
    }

    if (assoc_lookup(h, "sub_add_address")) {
        my_add_addresses(session);
        my_generate_page(session);
        return;
    }

    /* If we get this far then there is a fresh query */
    if ((query=assoc_lookup(h, "query")))
        query = string_trim_whitespace(query);

    if (!(query && query[0])) {
        session_message(session, "No search term provided");
        session_redirect(session, request, "abook_list");
        return;
    }

    if (assoc_lookup(h, "sub_ldap")) {
        do_ldap = T;
    } else if (assoc_lookup(h, "sub_local")) {
        do_ldap = NIL;
    } else if (lookup_ldap_available(lookup)) {
        do_ldap = T;
    } else
        do_ldap = NIL;

    if (do_ldap) {
        session_log(session,
                    "[cmd_abook_lookup] LDAP lookup for \"%s\"", query);
        if (!lookup_ldap(lookup, query)) {
            session_redirect(session, request, "abook_list");
            return;
        }
    } else {
        session_log(session,
                    "[cmd_abook_lookup] Local lookup for \"%s\"", query);
        if (!lookup_local(lookup, query, prefs->default_domain)) {
            session_redirect(session, request, "abook_list");
            return;
        }
    }

    if (lookup->count == 0) {
        session_message(session,
                        ("0 matches for \"%s\" (may indicate too"
                         " many possible matches)"), query);
    } else if (lookup->count == 1) {
        session_message(session, "1 match for \"%s\"", query);
    } else {
        session_message(session, "%lu matches for \"%s\"",
                        lookup->count, query);
    }

    if (!lookup->entries) {
        session_redirect(session, request, "abook_list");
        return;
    }

    my_generate_page(session);
}
