/* $Cambridge: hermes/src/prayer/prayer/cmd_expunge.c,v 1.2 2005/08/08 11:07:53 dpc22 Exp $ */
/************************************************
 *    Prayer - a Webmail Interface              *
 ************************************************/

/* Copyright (c) University of Cambridge 2000 - 2002 */
/* See the file NOTICE for conditions of use and distribution. */

#include "prayer_session.h"

void cmd_expunge(struct session *session)
{
    struct request *request = session->request;
    struct options *options = session->options;
    struct prefs *prefs = options->prefs;
    struct buffer *b = request->write_buffer;
    struct banner *banner = banner_create(request->pool);
    unsigned long msgno, count;
    MAILSTREAM *stream = session->stream;
    MESSAGECACHE *elt;

    if (!prefs->confirm_expunge) {
        cmd_expunge1(session);
        return;
    }

    html_start(session, b, "Confirm expunge");

    /* Count deleted messages in folder */
    for (count = 0, msgno = 1; msgno <= stream->nmsgs; msgno++) {
        if (!(elt = ml_elt(session, stream, msgno))) {
            session_redirect(session, request, "restart");
            return;
        }
        if (elt->deleted)
            count++;
    }

    if (count == 0) {
        session_message(session, "No messages to expunge");
        session_redirect(session, request, "list");
        return;
    }

    bprintf(b,
            "<h2 align=\"center\">Confirm expunge for %lu message%s</h2>"CRLF,
            count, (count != 1) ? "s" : "");

    banner_reset(banner, request->pool, T);
    banner_add(banner, "Cancel", "cross.gif", "list");
    banner_add(banner, "Okay", "tick.gif", "expunge1");
    banner_print(banner, b, session);

    html_end(b);

    /* Send out the response */
    response_html(request, 200);
}
